## qiskit-terra 0.5.6

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5 FATAL_ERROR)
file(STRINGS "qiskit/VERSION.txt" VERSION_NUM)
project (QISKit VERSION ${VERSION_NUM} LANGUAGES CXX)

# Verbose!!
set(CMAKE_VERBOSE_MAKEFILE True)
set(QISKIT_VERSION ${PROJECT_VERSION} CACHE INTERNAL "VERSION OF QISKIT")

include(cmake/defaults.cmake)

if (ENABLE_TARGETS_NON_PYTHON)
    # Add Toolchain utilities for C++ sources
    include(cmake/toolchain-utils.cmake)

    # Add C++ Qiskit Simulator
    add_subdirectory(${PROJECT_SOURCE_DIR}/src/qasm-simulator-cpp)

    # Add Python distributable package generator
    include(cmake/python-build.cmake)
    add_pypi_package_target(pypi_package both)
endif()

include(cmake/tests.cmake)

if (ENABLE_TARGETS_QA)
    # Add QA tools: lint, style and sphinx
    include(cmake/code-qa.cmake)
    add_lint_target()
    add_code_style_target()
    add_doc_target(html "./" "_build/")
    add_coverage_target()
endif()

=== Makefile ===
# Copyright 2017, IBM.
#
# This source code is licensed under the Apache License, Version 2.0 found in
# the LICENSE.txt file in the root directory of this source tree.

.PHONY: env env-dev lint test run doc

# Dependencies need to be installed on the Anaconda virtual environment.
env:
	if test $(findstring QISKitenv, $(shell conda info --envs)); then \
		bash -c "source activate QISKitenv;pip install -r requirements.txt"; \
	else \
		conda create -y -n QISKitenv python=3; \
		bash -c "source activate QISKitenv;pip install -r requirements.txt"; \
	fi;

run:
	bash -c "source activate QISKitenv;cd examples; cd jupyter;jupyter notebook"

# Ignoring generated ones with .py extension.
lint:
	pylint -rn qiskit test

style:
	pycodestyle --max-line-length=100 qiskit test

# Use the -s (starting directory) flag for "unittest discover" is necessary,
# otherwise the QuantumCircuit header will be modified during the discovery.
test:
	python3 -m unittest discover -s test -v

profile:
	python3 -m unittest discover -p "profile*.py" -v

coverage:
	coverage3 run --source qiskit -m unittest discover -s test -q
	coverage3 report

doc:
	export PYTHONPATH=$(PWD); \
	for LANGUAGE in "." "de" "ja"; do \
		better-apidoc -f -o doc/$$LANGUAGE/_autodoc -d 5 -e -t doc/_templates/better-apidoc qiskit qiskit/tools "qiskit/extensions/standard/[a-z]*"; \
		sphinx-autogen -t doc/_templates doc/$$LANGUAGE/_autodoc/*; \
		make -C doc -e BUILDDIR="_build/$$LANGUAGE" -e SOURCEDIR="./$$LANGUAGE" html; \
	done

sim:
	make -C src/qasm-simulator-cpp/src clean
	make -C src/qasm-simulator-cpp/src

# Build dependencies for the simulator target
depend:
	make -C src/qasm-simulator-cpp depend

coverage_erase:
	coverage erase

clean: coverage_erase
	make -C doc clean
	make -C doc -e BUILDDIR="_build/de" -e SOURCEDIR="./de" clean
	make -C doc -e BUILDDIR="_build/ja" -e SOURCEDIR="./ja" clean
	make -C src/qasm-simulator-cpp/src clean
	rm -f test/python/test_latex_drawer.tex test/python/test_qasm_python_simulator.pdf \
		test/python/test_save.json test/python/test_teleport.tex

=== requirements.txt ===
IBMQuantumExperience>=1.9.6
matplotlib>=2.1
networkx>=2.0
numpy>=1.13
ply>=3.10
scipy>=0.19
sympy>=1.0
pillow>=4.2.1

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python -msphinx
SPHINXPROJ    = QISKit SDK
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile clean

clean:
	rm -rf "$(BUILDDIR)"
	rm -rf "$(SOURCEDIR)/_autodoc"

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== src/qasm-simulator-cpp/CMakeLists.txt ===
# CMake config file to build the C++ Simulator
#
# For Windows, we always build static executables. QISKit provides the 
# necessary external binary libraries (.lib and .dll), these .lib come from an
# external source and they are simple import files, so we still need the .dll
# files in order to run the final executable. We only support MinGW64 toolchain
# so the static linking makes sure that other required libraries from this
# toolchain are included in the final executable. As MinGW64 can be installed
# anywhere in the system, the user needs to provide the PATH where the pthreads
# library is installed using the USER_LIB_PATH variable, like:
#     C:\..\out> cmake -DUSER_LIB_PATH=C:\path\to\mingw64\lib -G "MinGW Makefiles" ..
#
# For Linux and Mac, we can build both statically or dynamically. The former is the
# default. If you want to build a dynamic executable, you need to set
# STATIC_LINKING to True, example:
#     out$ cmake -DSTATIC_LINKING=False ..
#
# For Mac, you probably need to install static versions of the toolchain in order
# to make a static executable. Additionaly, the OpenMP features are only supported
# on GNU g++ compiler, CLang doesn't include it so if you are building with CLang
# you won't get all the performance.

project(qasm_simulator_cpp VERSION 1.0 LANGUAGES CXX)

set(QASM_SIMULATOR_CPP_SRC_DIR "${PROJECT_SOURCE_DIR}/src")
set(QASM_SIMULATOR_CPP_SRC
    "${QASM_SIMULATOR_CPP_SRC_DIR}/main.cpp")
set(QASM_SIMULATOR_CPP_EXTERNAL_LIBS
    "${QASM_SIMULATOR_CPP_SRC_DIR}/third-party/headers"
    "${QASM_SIMULATOR_CPP_SRC_DIR}/third-party/win64/lib"
	"${USER_LIB_PATH}")

# Target definition
add_executable(qasm_simulator_cpp ${QASM_SIMULATOR_CPP_SRC})

# Target properties: C++ program
set_target_properties(qasm_simulator_cpp PROPERTIES LINKER_LANGUAGE CXX)

# Toolchain options
set_property(TARGET qasm_simulator_cpp PROPERTY CXX_STANDARD 11)

if(STATIC_LINKING)
	# Hack: Seems like enable_cxx_compiler_flag_if_supported() is not properly
	# working on MacOS, when a flag is not supported, it cascades errors
	# to the rest of the flags being tested... and -static compilation on Mac
	# with gcc is failing...
	if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	    message(WARNING "Clang on MacOS doesn't support some -static-* flags. Switching to dyn compilation...")
	else()
	    # MacOS compilers don't support -static flag either
	    if(NOT APPLE)
	        enable_cxx_compiler_flag_if_supported("-static")
	    endif()
	    # This is enough to build a semi-static executable on Mac
	    enable_cxx_compiler_flag_if_supported("-static-libgcc")
	    enable_cxx_compiler_flag_if_supported("-static-libstdc++")
	endif()
endif()

if(NOT MSVC)
	# Compiler flags
	enable_cxx_compiler_flag_if_supported("-O3")
	# Warnings and Errors
	enable_cxx_compiler_flag_if_supported("-pedantic")
	enable_cxx_compiler_flag_if_supported("-Wall")
	enable_cxx_compiler_flag_if_supported("-Wfloat-equal")
	enable_cxx_compiler_flag_if_supported("-Wundef")
	enable_cxx_compiler_flag_if_supported("-Wcast-align")
	enable_cxx_compiler_flag_if_supported("-Wwrite-strings")
	enable_cxx_compiler_flag_if_supported("-Wmissing-declarations")
	enable_cxx_compiler_flag_if_supported("-Wredundant-decls")
	enable_cxx_compiler_flag_if_supported("-Wshadow")
	enable_cxx_compiler_flag_if_supported("-Woverloaded-virtual")
endif()

target_include_directories(qasm_simulator_cpp PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR})
target_include_directories(qasm_simulator_cpp PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR}/backends)
target_include_directories(qasm_simulator_cpp PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR}/engines)
target_include_directories(qasm_simulator_cpp PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR}/utilities)
target_include_directories(qasm_simulator_cpp PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR}/third-party/headers)

# For header only libraries
SET(CMAKE_FIND_LIBRARY_PREFIXES "" ${CMAKE_FIND_LIBRARY_PREFIXES})
SET(CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_FIND_LIBRARY_SUFFIXES} .hpp)

if(STATIC_LINKING)
    SET(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
    if(WIN32)
        SET(CMAKE_FIND_LIBRARY_SUFFIXES .lib ${CMAKE_FIND_LIBRARY_SUFFIXES})
    endif()
endif()

find_package(OpenMP)
if (OPENMP_FOUND)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
endif()

# Looking for external libraries
# This is a header-only library so we don't want it to link it, but we still
# want CMake to find it.
find_library(LIB_JSON
	NAMES json
	PATHS ${QASM_SIMULATOR_CPP_EXTERNAL_LIBS})
if(NOT LIB_JSON)
    message(FATAL_ERROR "JSON library not found!. Please provide with a USER_LIB_PATH to CMake so it can be searched there")
endif()

find_library(BLAS_LIB
	NAMES openblas mkl blas
	PATHS ${QASM_SIMULATOR_CPP_EXTERNAL_LIBS})
if(NOT BLAS_LIB)
	message(FATAL_ERROR "BLAS library not found!. Please provide with a USER_LIB_PATH to CMake so it can be searched there")
endif()

set(LIBRARIES PRIVATE ${BLAS_LIB})
				  
# Linking
target_link_libraries(qasm_simulator_cpp ${LIBRARIES})

set(QASM_SIMULATOR_CPP_OUTPUT_DIR $<TARGET_FILE_DIR:qasm_simulator_cpp>
	CACHE INTERNAL "Output directory for building QISKit C++ Simulator")

# TODO Windows 32 bits builds are not supported yet
set(ARCH_BITS "64")
if(ARCH32)
	set(ARCH_BITS "32")
endif()

# Copying necessary .dll files to output
# TODO look into "install()" CMake function
if(WIN32) # Windows 64 bits is also true here
	set(QASM_SIMULATOR_CPP_THIRD_PARTY_DLLS
		"${QASM_SIMULATOR_CPP_SRC_DIR}/third-party/win${ARCH_BITS}/dll/openblas.dll"
		CACHE INTERNAL "Third-party C++ Simulator DLLs")
	foreach(dll_file ${QASM_SIMULATOR_CPP_THIRD_PARTY_DLLS})
		add_custom_command(
			TARGET qasm_simulator_cpp
			POST_BUILD
			COMMAND ${CMAKE_COMMAND}
			ARGS -E copy ${dll_file} ${QASM_SIMULATOR_CPP_OUTPUT_DIR}/
		)
		# For 'make clean' target
		get_filename_component(FINAL_FILE ${dll_file} NAME)
		set_property(DIRECTORY APPEND PROPERTY
			ADDITIONAL_MAKE_CLEAN_FILES
				${QASM_SIMULATOR_CPP_OUTPUT_DIR}/${FINAL_FILE})
	endforeach()
endif()
	
# Tests
# TODO: Enable them when ready
#add_subdirectory(${QASM_SIMULATOR_CPP_DIR}/test)

=== src/qasm-simulator-cpp/Makefile ===
.SUFFIXES:.cc .o .c

all: sim

sim: 
	make -C src

depend: 
	./build_dependencies.sh

clean:
	make -C src clean

=== src/qasm-simulator-cpp/src/Makefile ===
INCLUDE = -I./ -I./backends -I./engines -I./utilities -I./third-party -I./third-party/headers
WARNINGS = -pedantic -Wall -Wextra -Wfloat-equal -Wundef -Wcast-align -Wwrite-strings -Wmissing-declarations -Wredundant-decls -Wshadow -Woverloaded-virtual
OPT = -O3 -march=native -ffast-math
OUTPUT_DIR = ../../../out/src/qasm-simulator-cpp

CC = g++

# Use Homebrew GNU g++ for enabling OpenMP on macOS
OS:=$(shell uname)
GCC7:=$(shell g++-7 --version | grep ^'command not found')
ifeq ($(OS)$(GCC7),Darwin)
	CC = g++-7
endif

# -march not supported on ppc64le (Power). Use -mcpu instead
ARCH:=$(shell uname -m)
ifeq ($(ARCH),ppc64le)
	OPT = -O3 -mcpu=native -ffast-math
endif

# Check if compiler is Apple LLVM and doesn't support OpenMP
APPLELLVM = $(shell ${CC} --version | grep ^Apple)
ifeq ($(APPLELLVM),)
	CPPFLAGS = $(USER_FLAGS) -std=c++11 -fopenmp $(OPT) $(INCLUDE) $(WARNINGS)
else
	CPPFLAGS = $(USER_FLAGS) -std=c++11 $(OPT) $(INCLUDE) $(WARNINGS)
endif

# BLAS distribution to use (change to use OpenBLAS or MKL for example)
ifeq ($(OS),Darwin)
	LIB_BLAS = -framework Accelerate
else
	LIB_BLAS = -llapack -lblas
endif
LIBS = -lpthread $(LIB_BLAS)

.SUFFIXES:.cpp .cc .o .c
.cpp.o:
	${CC} -c ${CPPFLAGS} ${DEFINES} -o  ${OUTPUT_DIR}/$@ $<
.cc.o:
	${CC} -c ${CPPFLAGS} ${DEFINES} -o  ${OUTPUT_DIR}/$@ $<
.c.o:
	${CC} -c ${CPPFLAGS} ${DEFINES} -o  ${OUTPUT_DIR}/$@ $<


all: directories sim
debug: directories sim_debug

directories:
	mkdir -p $(OUTPUT_DIR)

sim: main.o
	$(CC) $(CPPFLAGS) $(DEFINES) -o ${OUTPUT_DIR}/qasm_simulator_cpp ${OUTPUT_DIR}/main.o $(LIBS)

sim_debug: main.o
	$(CC) -g $(CPPFLAGS) $(DEFINES) -o ${OUTPUT_DIR}/qasm_simulator_cpp_debug ${OUTPUT_DIR}/main.o $(LIBS)

depend: 
	../build_dependencies.sh

clean:
	rm -rf ${OUTPUT_DIR}

=== src/qasm-simulator-cpp/test/CMakeLists.txt ===
# Tests
enable_testing()

# Set the output folder where your program will be created
set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR}/out/${CMAKE_BUILD_TYPE}/qasm_simulator_cpp/test/)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})

# TODO Put more descriptive test names
set(test_list one two)

foreach(test_item ${test_list})
  set(test_name ${test_item}_tests)
  add_executable(${test_name} main.cpp ${test_item}_test.cpp ${headers})
  target_include_directories(${test_name} PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR})
  target_include_directories(${test_name} PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR}/backends)
  target_include_directories(${test_name} PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR}/engines)
  target_include_directories(${test_name} PRIVATE ${QASM_SIMULATOR_CPP_SRC_DIR}/utilities)
  set_target_properties(${test_name} PROPERTIES LINKER_LANGUAGE CXX)
  # set_property(TARGET ${test_name} PROPERTY CXX_STANDARD 11)
  target_link_libraries(${test_name} ${QASM_SIMULATOR_CPP_EXTERNAL_LIBRARIES})
  add_test(NAME ${test_name} COMMAND ${test_name})

  if(NOT CMAKE_GENERATOR MATCHES "^Mingw")
    add_custom_target(${test_item}_test
      COMMAND ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure -R ${test_name})
    add_custom_target(${test_item}_check
      COMMAND ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure -R ${test_name}
      DEPENDS ${test_name})
  endif()
endforeach()

# Toolchain options
# Compiler flags
_enable_cxx_compiler_flag_if_supported("-O3")
_enable_cxx_compiler_flag_if_supported("-march=native")
_enable_cxx_compiler_flag_if_supported("-fopenmp")

# Warnings and Errors
_enable_cxx_compiler_flag_if_supported("-pedantic")
_enable_cxx_compiler_flag_if_supported("-Wall")
_enable_cxx_compiler_flag_if_supported("-Wfloat-equal")
_enable_cxx_compiler_flag_if_supported("-Wundef")
_enable_cxx_compiler_flag_if_supported("-Wcast-align")
_enable_cxx_compiler_flag_if_supported("-Wwrite-strings")
_enable_cxx_compiler_flag_if_supported("-Wmissing-declarations")
_enable_cxx_compiler_flag_if_supported("-Wredundant-decls")
_enable_cxx_compiler_flag_if_supported("-Wshadow")
_enable_cxx_compiler_flag_if_supported("-Woverloaded-virtual")

=== src/qasm-simulator-cpp/test/Makefile ===

CC = g++
#CC = g++-7 # use Homebrew GNU g++ for enabling OpenMP on macOS

INCLUDE = -I../src/utilities/
WARNINGS = -pedantic -Wall -Wextra -Wfloat-equal -Wundef -Wcast-align -Wwrite-strings -Wredundant-decls -Wshadow 
OPT = -O3 -march=native -ffast-math

# Check if compiler is Apple LLVM and doesn't support OpenMP
APPLELLVM = $(shell ${CC} --version | grep ^Apple)
ifeq ($(APPLELLVM),)
	CPPFLAGS = $(USER_FLAGS) -std=c++11 -fopenmp $(OPT) $(INCLUDE) $(WARNINGS)
else
	CPPFLAGS = $(USER_FLAGS) -std=c++11 $(OPT) $(INCLUDE) $(WARNINGS)
endif

# BLAS distribution to use (change to use OpenBLAS or MKL for example)
OS:=$(shell uname)
ifeq ($(OS),Darwin)
	LIB_BLAS = -framework Accelerate
else
	LIB_BLAS = -llapack -lblas
endif
LIBS = -lpthread $(LIB_BLAS)

.SUFFIXES:.cpp .cc .o .c
.cpp.o:
	${CC} -c ${CPPFLAGS} ${DEFINES} -o $@ $<
.cc.o:
	${CC} -c ${CPPFLAGS} ${DEFINES} -o $@ $<
.c.o:
	${CC} -c ${CPPFLAGS} ${DEFINES} -o $@ $<


all: test_qubit_vector

test_qubit_vector: test_qubit_vector.o
	$(CC) $(CPPFLAGS) $(DEFINES) -o test_qubit_vector test_qubit_vector.o $(LIBS)

sim_debug: main.o
	$(CC) -g $(CPPFLAGS) $(DEFINES) -o ${OUTPUT_DIR}/qiskit_simulator_debug ${OUTPUT_DIR}/main.o $(LIBS)

clean:
	rm -rf *.o test_qubit_vector

## qiskit-terra 0.12.0

=== Makefile ===
# This code is part of Qiskit.
#
# (C) Copyright IBM 2017.
#
# This code is licensed under the Apache License, Version 2.0. You may
# obtain a copy of this license in the LICENSE.txt file in the root directory
# of this source tree or at http://www.apache.org/licenses/LICENSE-2.0.
#
# Any modifications or derivative works of this code must retain this
# copyright notice, and modified files need to carry a notice indicating
# that they have been altered from the originals.

OS := $(shell uname -s)

ifeq ($(OS), Linux)
  NPROCS := $(shell grep -c ^processor /proc/cpuinfo)
else ifeq ($(OS), Darwin)
  NPROCS := 2
else
  NPROCS := 0
endif # $(OS)

ifeq ($(NPROCS), 2)
	CONCURRENCY := 2
else ifeq ($(NPROCS), 1)
	CONCURRENCY := 1
else ifeq ($(NPROCS), 3)
	CONCURRENCY := 3
else ifeq ($(NPROCS), 0)
	CONCURRENCY := 0
else
	CONCURRENCY := $(shell echo "$(NPROCS) 2" | awk '{printf "%.0f", $$1 / $$2}')
endif

.PHONY: env lint test test_ci

# Dependencies need to be installed on the Anaconda virtual environment.
env:
	if test $(findstring qiskitenv, $(shell conda info --envs | tr '[:upper:]' '[:lower:]')); then \
		bash -c "source activate Qiskitenv;pip install -r requirements.txt"; \
	else \
		conda create -y -n Qiskitenv python=3; \
		bash -c "source activate Qiskitenv;pip install -r requirements.txt"; \
	fi;

# Ignoring generated ones with .py extension.
lint:
	pylint -rn qiskit test

style:
	pycodestyle --max-line-length=100 qiskit test

# Use the -s (starting directory) flag for "unittest discover" is necessary,
# otherwise the QuantumCircuit header will be modified during the discovery.
test:
	python3 -m unittest discover -s test/python -v

test_ci:
	echo "Detected $(NPROCS) CPUs running with $(CONCURRENCY) workers"
	stestr run --concurrency $(CONCURRENCY)

test_randomized:
	python3 -m unittest discover -s test/randomized -v

coverage:
	coverage3 run --source qiskit -m unittest discover -s test/python -q
	coverage3 report

coverage_erase:
	coverage erase

clean: coverage_erase ;

=== requirements.txt ===
jsonschema>=2.6
marshmallow>=3,<4
marshmallow_polyfield>=5.7,<6
networkx>=2.2;python_version>'3.5'
networkx>=2.2,<2.4;python_version=='3.5'
numpy>=1.13
ply>=3.10
psutil>=5
scipy>=1.0
sympy>=1.3
dill>=0.3

=== debian/changelog ===
qiskit-terra (0.12.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch: Support Python 3.9, in test infrastructure. Closes: #972374

 -- Stefano Rivera <stefanor@debian.org>  Sat, 17 Oct 2020 11:53:16 -0700

qiskit-terra (0.12.0-2) unstable; urgency=medium

  * d/patches: backport upstream fix. Closes: #964669

 -- Diego M. Rodriguez <diego@moreda.io>  Sat, 15 Aug 2020 12:26:42 +0200

qiskit-terra (0.12.0-1) unstable; urgency=medium

  * New upstream release. Closes: #933060

 -- Diego M. Rodriguez <diego@moreda.io>  Thu, 11 Jun 2020 18:22:03 +0200

qiskit-terra (0.5.6-1) unstable; urgency=low

  * Initial release. Closes: #880994

 -- Luciano Bello <luciano@debian.org>  Sat, 07 Jul 2018 09:51:09 -0400

=== debian/control ===
Source: qiskit-terra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Enrique de la Torre <indisoluble_dev@me.com>,
           Luciano Bello <luciano@debian.org>,
           Diego M. Rodriguez <diego@moreda.io>
Section: science
Priority: optional
Build-Depends: cython3 (>= 0.27.1),
               debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-all-dev,
               python3-setuptools,
# Upstream core dependencies
               python3-dill (>= 0.3),
               python3-jsonschema (>= 2.6),
               python3-marshmallow (>= 3.2),
               python3-marshmallow-polyfield (>= 5.7),
               python3-networkx (>= 2.4),
               python3-numpy (>= 1.13),
               python3-ply (>= 3.10),
               python3-psutil (>= 5),
               python3-scipy (>= 1.0),
               python3-sympy (>= 1.3),
# Upstream optional dependencies
               python3-matplotlib (>= 2.1),
               python3-pil,
               python3-pydot,
               python3-seaborn (>= 0.9.0),
# unavailable upstream optional dependencies
#               python3-ipywidgets (>= 7.3.0),
#               python3-pylatexenc (>= 1.4),
# Test dependencies
               python3-ddt,
               python3-nbconvert,
               python3-nbformat,
               python3-pytest
Vcs-Browser: https://salsa.debian.org/science-team/qiskit-terra
Vcs-Git: https://salsa.debian.org/science-team/qiskit-terra.git
Homepage: https://qiskit.org/
Standards-Version: 4.5.0
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-qiskit-terra
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-matplotlib (>= 2.1),
            python3-pil,
            python3-pydot,
            python3-seaborn (>= 0.9.0)
# unavailable upstream optional dependencies
#            python3-ipywidgets (>= 7.3.0),
#            python3-pylatexenc (>= 1.4),
Description: Quantum Information Science Kit (Qiskit) for Python 3
 Qiskit (Quantum Information Science Kit) is a collection of software developed
 by IBM Research for working with short depth quantum circuits and building
 near term applications and experiments on quantum computers.
 .
 This package contains Terra, which provides the foundations for Qiskit.
 It allows the user to write quantum circuits easily, and takes care of
 the constraints of real hardware (the transpiler).

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export PYBUILD_TEST_PYTEST=1
# Add manually qiskit/schemas/examples to the build dir, removing them
# after the tests are run, as they are needed by "test_schemas.py".
export PYBUILD_BEFORE_TEST=cp -r {dir}/qiskit/schemas/examples {build_dir}/qiskit/schemas
export PYBUILD_AFTER_TEST=rm -r {build_dir}/qiskit/schemas/examples
# Skip some tests:
# * TestVisualizationUtils.test_generate_latex_*: require pylatexenc
# * TestLatexSourceGenerator: require pylatexenc
# * TestJupyter.test_jupyter_jobs_pbars: No such kernel named python3
export PYBUILD_TEST_ARGS=test/python -k \
	"not (test_generate_latex or TestLatexSourceGenerator \
	or test_jupyter_jobs_pbars)"

%:
	dh $@ --with python3 --buildsystem=pybuild

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/qiskit-terra-$1\.tar\.gz/ \
  https://github.com/Qiskit/qiskit-terra/releases .*/v?(\d\S+)\.tar\.gz
